/********************************** (C) COPYRIGHT *******************************
* File Name          : FLASH.C
* Author             : WCH
* Version            : V1.0
* Date               : 2017/3/8
* Description        : CH561 EEPROM&FLASH DEMO
*                      
*                      (1)0Ϣ,115200bps;
*                      (2)ʵEEPROMȡԼ̹̣CH561оƬ28KEEPROM
*                      (3)дݿͨƬȡҲʹ"WCHISPTool_Setup.exe"ȡ
*                      (4)ʾFLASHдУ鹦		
					
˵ӿļ\SRC\ISPXT56X.O
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>

#ifndef    DEBUG
#define    DEBUG  1
#endif

#include "CH561SFR.H"
#include "SYSFREQ.H"
#include "ISPXT56X.H"
                              

/* һLEDڼʾĽ,͵ƽLED */
#define LED_OUT_INIT( LED )     { R32_PB_OUT |= LED; R32_PB_DIR |= LED; }          /* LED ߵƽΪ */
#define LED_OUT_ACT( LED )      { R32_PB_CLR |= LED; }                             /* LED ͵ƽLEDʾ */
#define LED_OUT_INACT( LED )    { R32_PB_OUT |= LED; }                             /* LED ߵƽرLEDʾ */

__align(4)    UINT8 my_buffer[1024];

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void IRQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS/ 8 / 115200;                                              /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/
int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : CH56X_EEPROM
* Description    : EEPROM
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/
void CH56X_EEPROM( void ) 
{
    UINT32 i;
    
    PRINT("Eeprom Erase:\n");
    i = EEPROM_ERASE(0x2000,0x1000);                                            /* 0X2000ַʼ4K */
    if( i ){
        PRINT("    ***Error***\n");
    }
    for( i=0;i!=64;i++ )my_buffer[i] = i;
    PRINT("Eeprom Write:\n");
    i = EEPROM_WRITE( 0x2000,my_buffer,64 );                                    /* ַ0X2000д64ֽڵ */
    if( i ){
        PRINT("    ***Error***\n");
    }
    PRINT("Eeprom Read:\n");
    EEPROM_READ( 0x2000,my_buffer,64 );                                         /* EEPROMȡַ0x0000ݣȡ64ֽ */
    for( i=0;i!=64;i++ ){
        if(i%8 == 0) PRINT("\n");
        PRINT("%02x ",(UINT16)my_buffer[i]);
    }
    PRINT("\n");
}

/*******************************************************************************
* Function Name  : CH56X_EEPROM
* Description    : flash 
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/
void CH56X_FLASH_CODE( void ) 
{
    UINT32 i;
    
    FLASH_ROM_LOCK( 0x00 );                                                          //ȽFLASH
    PRINT("flash Erase:\n");
    i = FLASH_ROM_ERASE( 0X20000,1024*4);                                            /* 0X20000ַʼ4K */
    if( i ){
        PRINT("    ***Erase Error***\n");
    }
    else{
        PRINT("    *** erase ok***\n");
    }
    for( i=0;i!=64;i++ )my_buffer[i] = i;
    PRINT("flash Write:\n");
    i = FLASH_ROM_WRITE( 0X20000,my_buffer,64 );                                    /* ַ0X20000д64ֽڵ */
    if( i ){
        PRINT("    *** Write Error***\n");
    }
    else{
        PRINT("    *** write ok***\n");
    }
    PRINT("flash  verify:\n");
    i = FLASH_ROM_VERIFY( 0X20000,my_buffer,64 );                                    /*  УǷȷ */
    if( i ){
        PRINT("    *** verify Error***\n");
    }
    else{
        PRINT("    *** verify ok***\n");
    }
    FLASH_ROM_LOCK(FLASH_ROM_LOCK_AUTO);                                             //ȫLOCK
    PRINT("\n");
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
int main( void ) 
{
    UINT8 i;

    LED_OUT_INIT( (1<<3|1<<4|1<<5) );
    LED_OUT_ACT( (1<<3|1<<4|1<<5) );
    Delay_ms( 100 );
    LED_OUT_INACT( (1<<3|1<<4|1<<5) ); 
    mInitSTDIO( );                                                               
    PRINT("Edit Date and Time is: "__DATE__" , " __TIME__"\n");
    GET_UNIQUE_ID( my_buffer );
    PRINT("chip id: ");
    for(i=0;i<8;i++) PRINT("%-2x ",my_buffer[i]);
    PRINT("\n");
    CH56X_EEPROM( );
    CH56X_FLASH_CODE( );
    while(1);
}

/*********************************** endfile **********************************/
