/********************************** (C) COPYRIGHT *******************************
* File Name          : SPI0_HOST.C
* Author             : WCH
* Version            : V1.0
* Date               : 2017/3/8
* Description        : CH561 SPI0_HOST DEMO
*                     
*                      (1)0Ϣ,115200bps;
*                      (2)SPI0ӳ,ѯʽͺͽ.
*******************************************************************************/



/******************************************************************************/
/* ͷļ */
#include <stdio.h>
#include <string.h>
#include "CH561SFR.H"
#include "SYSFREQ.H"

/* һLEDڼʾĽ,͵ƽLED */
#define LED                     1<<3

#define LED_OUT_INIT(  )     { R32_PB_OUT |= LED; R32_PB_DIR |= LED; }         /* LED ߵƽΪ */
#define LED_OUT_ACT(  )      { R32_PB_CLR |= LED; }                            /* LED ͵ƽLEDʾ */
#define LED_OUT_INACT(  )    { R32_PB_OUT |= LED; }                            /* LED ߵƽرLEDʾ */
UINT8 SPI_BUF[1024];

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void IRQ_Handler( void )   
{
    while(1);
} 

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : SPI_MASTER_INIT
* Description    : SPIģʽʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void SPI_MASTER_INIT ( void )
{
    R8_SPI0_CTRL_MOD &= ~ RB_SPI_MODE_SLAVE;                                    /* ģʽüĴ,ģʽ */
    R8_SPI0_CTRL_MOD |= RB_SPI_MOSI_OE|RB_SPI_SCK_OE;                           /* MOSI,SCK output enable */
    R8_SPI0_CTRL_MOD |= ( RB_SPI_FIFO_DIR | RB_SPI_ALL_CLEAR );                 /* FIFO,FIFOĬΪ*/
    R8_SPI0_CTRL_MOD &= ~RB_SPI_ALL_CLEAR;                                      /* FIFO,FIFOĬΪ*/
    R8_SPI0_CLOCK_DIV = 0x0a;                                                   /* 10Ƶ100/10=10M */
    R32_PB_DIR |= (MOSI | SCK0 | SCS );                                         /* MOSISCK0, SCSΪ */
    R32_PB_PU  |=  SCS ;
    R8_SPI0_CTRL_DMA = 0x00;                                                    /* DMAʽ */
}

/*******************************************************************************
* Function Name  : SPI0_MasterTransByte
* Description    : 
* Input          : data - 
* Output         : None
* Return         : None
*******************************************************************************/
void SPI0_MasterTransByte( UINT8 data )
{
    R8_SPI0_CTRL_MOD &= ~RB_SPI_FIFO_DIR;                                       /* ÷Ϊ */
    R16_SPI0_TOTAL_CNT = 1;                                                     /* Ϊ1 */
    R32_SPI0_FIFO = data;                                                       /* FIFOдݣFIFOҳȲΪ0ʱ */
    while( R8_SPI0_FIFO_COUNT != 0 );                                           /* ȴݷ */
    R8_SPI0_CTRL_MOD |= RB_SPI_FIFO_DIR;                                        /* ĬϷΪ */
}

// ʹSPIݻĴ
void SPI0_MasterTrans1( UINT8 data )
{
    R8_SPI0_CTRL_MOD &= ~RB_SPI_FIFO_DIR;                                        /* λ0 */
    R8_SPI0_BUFFER = data;                                                       /* дݲ */
    while( R8_SPI0_INT_FLAG&RB_SPI_FREE ==0 );                                   /* ȴݴ */
    R8_SPI0_CTRL_MOD |= RB_SPI_FIFO_DIR;                                         /* ĬϷΪ */
}

// ʹFIFOͶֽ
void SPI0_MasterTrans( UINT16 len, UINT8 *pbuf )
{
    UINT16 sendlen;
    
    sendlen = len;
    R8_SPI0_CTRL_MOD &= ~RB_SPI_FIFO_DIR;                                       /* ݷΪ */
    R16_SPI0_TOTAL_CNT = len;                                                   /* Ҫ͵ݳ */
    while( sendlen ){                                                           /* Ҫ͵ݳ */
        if( R8_SPI0_FIFO_COUNT < SPI0_FIFO_SIZE ){                              /* FIFOδݸСFIFOСԼFIFOд */
            R32_SPI0_FIFO = *pbuf;
            pbuf++;
            sendlen--;
        }
    }
    while( R8_SPI0_FIFO_COUNT != 0 );                                           /* ȴFIFOеȫ */
    R8_SPI0_CTRL_MOD |= RB_SPI_FIFO_DIR;                                        /* ĬϷΪ */
}

/*******************************************************************************
* Function Name  : SPI0_MASTER_Recv
* Description    : 
* Input          : None
* Output         : None
* Return         : data -յ
*******************************************************************************/
UINT8 SPI0_MasterRecvByte( void )
{
    R16_SPI0_TOTAL_CNT = 1;                                                     /* Ϊ1 */
    while( R8_SPI0_FIFO_COUNT == 0 );                                           /* ȴݻ */
    return R8_SPI0_FIFO;                                                        /* FIFOе */
}
// ʹSPIݻĴȡ
void SPI0_MasterRecv1( UINT8 len, UINT8 *pbuf )
{
    R8_SPI0_BUFFER = 0xff;                                                      /* */
    while(len>1){
//        Delay_us( 10 );
        *pbuf = R8_SPI0_BUFFER;                                                 /* ȡݣ */
        pbuf++;
        len--;
    }
//    Delay_us( 10 );
    R8_SPI0_CTRL_MOD &= ~RB_SPI_FIFO_DIR;                                       /* λ */
    *pbuf = R8_SPI0_BUFFER;                                                     /* ȡһֽ */
    R8_SPI0_CTRL_MOD |= RB_SPI_FIFO_DIR;                                        /* ĬϷΪ */
}

// ʹFIFOȡֽ
void SPI0_MasterRecv( UINT16 len, UINT8 *pbuf )
{
    UINT16 readlen;
    
    readlen = len;
    R16_SPI0_TOTAL_CNT = len;                                                   /* ҪյݳȣFIFOΪ볤ȲΪ0 */
    while( readlen ){                                                           /* ʣݳȣFIFOݣÿһֽڳȻԶ1 */
        if( R8_SPI0_FIFO_COUNT ){                                               /* ѯFIFOǷ */
            *pbuf = R8_SPI0_FIFO;                                               /*  */
            pbuf++;
            readlen--;
        }
    }
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main( void ) 
{
    UINT8 i;
    UINT8 spi_buf[1024];

    LED_OUT_INIT( );
    LED_OUT_ACT( );                                                             /* LEDһʾ */
    Delay_ms( 100 );
    LED_OUT_INACT( );
    mInitSTDIO( );                                                              /* 0ʼ */
    PRINT("START SPI0 HOST:\n");  
    SPI_MASTER_INIT ( );                                                        /* ģʽʼ */
    R32_PB_CLR |= SCS;                                                          /* Ƭѡʹ */
    while(1){
        SPI0_MasterTransByte(0xaa);                                             /*  */
        Delay_ms( 10);
        SPI0_MasterRecv( 100, spi_buf);
        PRINT("\r\n");
        for(i=0;i<10;i++) PRINT("%2lX ", spi_buf[i]);                           /* ͨ0ӡ */
        PRINT("\r\n");
        Delay_ms( 5000 );
    }
}

/*********************************** endfile **********************************/
