/********************************** (C) COPYRIGHT *******************************
* File Name          : SPI1_HOST.C
* Author             : WCH
* Version            : V1.0
* Date               : 2017/3/8
* Description        : CH561 SPI0_HOST DEMO
*                        
*                      (1)0Ϣ,115200bps;
*                      (2)SPI0ӳ,ѯʽͺͽ.
*******************************************************************************/



/******************************************************************************/
/* ͷļ */

#include <stdio.h>
#include <string.h>
#include "CH561SFR.H"
#include "SYSFREQ.H"

/* һLEDڼʾĽ,͵ƽLED */
#define LED                     1<<3

#define LED_OUT_INIT(  )     { R32_PB_OUT |= LED; R32_PB_DIR |= LED; }         /* LED ߵƽΪ */
#define LED_OUT_ACT(  )      { R32_PB_CLR |= LED; }                            /* LED ͵ƽLEDʾ */
#define LED_OUT_INACT(  )    { R32_PB_OUT |= LED; }                            /* LED ߵƽرLEDʾ */

/*******************************************************************************
* Function Name  : IRQ_Handler
* Description    : IRQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void IRQ_Handler( void )   
{
    while(1);
} 

/*******************************************************************************
* Function Name  : FIQ_Handler
* Description    : FIQжϺ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

__irq void FIQ_Handler( void )
{
    while(1);
}

/*******************************************************************************
* Function Name  : mInitSTDIO
* Description    : Ϊprintfgetkeyʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void mInitSTDIO( void )
{
    UINT32    x, x2;

    x = 10 * FREQ_SYS * 2 / 16 / 115200;                                        /* 115200bps */
    x2 = x % 10;
    x /= 10;
    if ( x2 >= 5 ) x ++;                                                        /*  */
    R8_UART0_LCR = 0x80;                                                        /* DLABλ1 */
    R8_UART0_DIV = 1;                                                           /* ԤƵ */
    R8_UART0_DLM = x>>8;
    R8_UART0_DLL = x&0xff;

    R8_UART0_LCR = RB_LCR_WORD_SZ ;                                             /* ֽڳΪ8 */
    R8_UART0_FCR = RB_FCR_FIFO_TRIG|RB_FCR_TX_FIFO_CLR|RB_FCR_RX_FIFO_CLR |    
                   RB_FCR_FIFO_EN ;                                             /* FIFOΪ14巢ͺͽFIFOFIFOʹ */
    R8_UART0_IER = RB_IER_TXD_EN;                                               /* TXD enable */
    R32_PB_SMT |= RXD0|TXD0;                                                    /* RXD0 schmitt input, TXD0 slow rate */
    R32_PB_PD &= ~ RXD0;                                                        /* disable pulldown for RXD0, keep pullup */
    R32_PB_DIR |= TXD0;                                                         /* TXD0 output enable */
}

/*******************************************************************************
* Function Name  : fputc
* Description    : ͨϢ
* Input          : c-- writes the character specified by c 
*                  *f--the output stream pointed to by *f
* Output         : None
* Return         : None
*******************************************************************************/

int fputc( int c, FILE *f )
{
    R8_UART0_THR = c;                                                           /*  */
    while( ( R8_UART0_LSR & RB_LSR_TX_FIFO_EMP ) == 0 );                        /* ȴݷ */
    return( c );
}

/*******************************************************************************
* Function Name  : SPI1_MasterInit
* Description    : SPIģʽʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

void SPI1_MasterInit ( void )
{
    R8_SPI1_CTRL_MOD = RB_SPI1_SDO_OE | RB_SPI_SCK_OE;
    R8_SPI1_CLOCK_DIV = 0x0a;                                                   /* 10Ƶ100/10=10M */
    R32_PB_DIR |= (SDO | SCK1 | ADCS );                                         /* SDO, SCK1ADCSΪ */
    R32_PB_PU  |=  ADCS ;
    R8_SPI1_CTRL_DMA = 0x00;                                                    /* DMAʽ */
}

/*******************************************************************************
* Function Name  : SPI1_MasterTrans
* Description    : һֽ
* Input          : data - 
* Output         : None
* Return         : None
*******************************************************************************/

void SPI1_MasterTrans( UINT8 data )
{
    R8_SPI1_CTRL_MOD &= ~RB_SPI_FIFO_DIR;                                       /* ÷Ϊ */
    R32_SPI1_FIFO = data;
    R16_SPI1_TOTAL_CNT = 1;
    while( R8_SPI1_FIFO_COUNT != 0 );                                           /* ȴݷ */
}

/*******************************************************************************
* Function Name  : SPI1_MasterRecv
* Description    : һֽ
* Input          : None
* Output         : None
* Return         : data -յ
*******************************************************************************/

UINT8 SPI1_MasterRecv( void )
{
    R8_SPI1_CTRL_MOD |= RB_SPI_FIFO_DIR;                                        /* ÷Ϊ */
    R16_SPI1_TOTAL_CNT = 1;
    while( R8_SPI1_FIFO_COUNT == 0 );                                           /* ȴݻ */
    return R8_SPI1_FIFO;
}

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

int main( void ) 
{
    LED_OUT_INIT( );
    LED_OUT_ACT( );                                                             /* LEDһʾ */
    Delay_ms( 100 );
    LED_OUT_INACT( );
    mInitSTDIO( );                                                              /* 0ʼ */
    PRINT("SPI1 HOST DEMO......\n");  
    SPI1_MasterInit( );                                                         /* ģʽʼ */
    while(1){
        R32_PB_CLR |= ADCS;                                                     /* Ƭѡʹ */
        SPI1_MasterTrans(0xaa);                                                 /*  */
        R32_PB_OUT |= ADCS;             
        Delay_us( 10 )    ;
    }
}

/*********************************** endfile **********************************/
